import { Server, Model } from 'miragejs';
import api from './datasets/api';

export function makeServer({ environment = 'development' } = {}) {
  let server = new Server({
    environment,

    models: {
      branches: Model,
      commits: Model
    },

    seeds(server) {
      server.db.loadData(api);
    },

    routes() {
      this.namespace = 'api';

      this.get('/branches', schema => schema.branches.all());
      this.get('/commits', schema => schema.commits.all());
    }
  });

  return server;
}
